/**---------------------------------------------------------------------
***	
***	file:		xmbutton.c
***
***	project:	Motif Widgets example programs
***
***	description:	This program creates a PushButton widget.
***	
***	
***			(c) Copyright 1989 by Open Software Foundation, Inc.
***			    All Rights Reserved.
***
***			(c) Copyright 1989 by Hewlett-Packard Company.
***
***-------------------------------------------------------------------*/


/*  include files  */

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>


/*  functions defined in this program  */

void main();
void activateCB(); /* Callback for the PushButton */


/*  global variables  */

char *btn_text;	/* button label pointer for compound string */


/*-------------------------------------------------------------
**	main - main logic for demo1 program
*/
void main (argc,argv)
int argc;
char **argv;
{
	Widget	toplevel; /*  Shell widget	*/
	Widget	button;	/*  PushButton widget	*/
	Arg	args[10]; /*  arg list		*/
	register int n;	/*  arg count		*/

/*  initialize toolkit  */
	toplevel = XtInitialize ("main", "XMdemos", NULL, NULL, &argc, argv);

/*  create compound string for the button text  */
	btn_text = XmStringCreateLtoR("Push Here", XmSTRING_DEFAULT_CHARSET);

/*  set up arglist  */
	n = 0;
	XtSetArg (args[n], XmNlabelType, XmSTRING);  n++;
	XtSetArg (args[n], XmNlabelString, btn_text);  n++;
	XtSetArg (args[n], XmNwidth, 250);  n++;
	XtSetArg (args[n], XmNheight, 150);  n++;
/*  create button  */
	button = XtCreateManagedWidget ("button", xmPushButtonWidgetClass,
	  toplevel, args, n);
/*  add callback  */
	XtAddCallback (button, XmNactivateCallback, activateCB, NULL);
/*  realize widgets  */
	XtRealizeWidget (toplevel);
/*  process events  */
	XtMainLoop ();
}


/*-------------------------------------------------------------
**	activateCB - callback for button
*/
void activateCB (w, client_data, call_data) 
Widget	w;		/*  widget id		*/
caddr_t	client_data;	/*  data from application   */
caddr_t	call_data;	/*  data from widget class  */
{
/*  print message, free compound string memory, and terminate program  */
	printf ("PushButton selected.\n");
	XtFree(btn_text);
	exit (0);
}

