/* Option Menu Example */

#include <Xm/Xm.h>
#include <Xm/PushBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/RowColumn.h>


/*********** Callback for the Pushbuttons ***********************/

void ButtonCB (w, client_data, call_data) 
Widget	w;		/*  widget id		*/
caddr_t	client_data;	/*  data from application   */
caddr_t	call_data;	/*  data from widget class  */
{
   /*  print message and terminate program  */
   printf ("Option %s selected.\n", client_data);
	
}

/***********************Main Logic for Program ********************/


void main (argc, argv)
int argc;
char **argv;
{
   Widget toplevel, pulldown1, pulldown2, rc;
   Widget option_menus[2], options1[3], options2[3];
   Arg args[6];
   XmString string;

/* Initialize toolkit */
   toplevel = XtInitialize (argv[0], "OptionMenu", NULL, 0, &argc, argv);

/* Create RowColumn in toplevel */

   XtSetArg(args[0], XmNwidth, 375);
   XtSetArg(args[1], XmNheight,175);
   XtSetArg(args[2], XmNresizeWidth, False);
   XtSetArg(args[3], XmNresizeHeight, False);
   XtSetArg(args[4], XmNnumColumns, 1);
   XtSetArg(args[5], XmNpacking, XmPACK_COLUMN);
   rc = XmCreateRowColumn(toplevel, "rc", args, 6);
   XtManageChild(rc);

/* Create two pulldown menus in rc */

   pulldown1 = (Widget)XmCreatePulldownMenu(rc, "pulldown1", NULL, 0);

   string = XmStringCreate("A1-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'A'); 
   options1[0] = XmCreatePushButtonGadget(pulldown1, "option1a", args, 2);
   XmStringFree(string);   
   XtAddCallback(options1[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"1A");

   string = XmStringCreate("B1-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'B');
   options1[1] = XmCreatePushButtonGadget(pulldown1, "option1b", args, 2);
   XmStringFree(string);   
   XtAddCallback(options1[1], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"1B");

   string = XmStringCreate("C1-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'C');
   options1[2] = XmCreatePushButtonGadget(pulldown1, "option1c", args, 2);
   XmStringFree(string);   
   XtAddCallback(options1[2], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"1C");
   XtManageChildren(options1, 3);


   pulldown2 = (Widget)XmCreatePulldownMenu(rc, "pulldown2", NULL, 0);

   string = XmStringCreate("     A2-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'A'); 
   options2[0] = XmCreatePushButtonGadget(pulldown2, "option2a", args, 2);
   XmStringFree(string);   
   XtAddCallback(options2[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"2A");

   string = XmStringCreate("     B2-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'B');
   options2[1] = XmCreatePushButtonGadget(pulldown2, "option2b", args, 2);
   XmStringFree(string);   
   XtAddCallback(options2[1], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"2B");

   string = XmStringCreate("     C2-option", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'C');
   options2[2] = XmCreatePushButtonGadget(pulldown2, "option2c", args, 2);
   XmStringFree(string);   
   XtAddCallback(options2[2], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"2C");
   XtManageChildren(options2, 3);

/* Create option menus and attach the two pulldown menus */


/*   string = XmStringCreate("First Option Set:", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
*/
   XtSetArg(args[0], XmNmnemonic, 'F');
   XtSetArg(args[1], XmNsubMenuId, pulldown1);
   XtSetArg(args[2], XmNmenuHistory, options1[2]);
   option_menus[0] = XmCreateOptionMenu(rc, "option_menu1", args, 3);
/*
   XmStringFree(string);   
 */

/*
   string = XmStringCreate("Second Option Set:", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
 */
   XtSetArg(args[0], XmNmnemonic, 'S');
   XtSetArg(args[1], XmNsubMenuId, pulldown2); 
   XtSetArg(args[2], XmNmenuHistory, options2[0]);
   option_menus[1] = XmCreateOptionMenu(rc, "option_menu2", args, 3);
/*
   XmStringFree(string);   
 */
   XtManageChildren(option_menus, 2);

/* Get and dispatch events */

   XtRealizeWidget(toplevel);

   XtMainLoop();
}












