/* Pulldown Menu Example */

#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#include <Xm/Form.h>
#include <Xm/CascadeB.h>

/*********** Callback for the pushbuttons in the pulldown menu. ************/

void ButtonCB (w, client_data, call_data) 
Widget	w;		/*  widget id		*/
caddr_t	client_data;	/*  data from application   */
caddr_t	call_data;	/*  data from widget class  */
{
   /*  print message and terminate program  */
   printf ("Button %s selected.\n", client_data);
	
}

/*********************Main Logic*******************************************/

void main (argc, argv)
int argc;
char **argv;

{
   Widget toplevel, form, menubar;
   Widget menubarBtn[3], pulldowns[2];
   Widget buttons1[3], buttons2[3];
   Arg args [4];
   XmString string;  
 
/* Initialize toolkit and create form and menubar */

   toplevel = XtInitialize (argv[0], "PulldownMenu", NULL, 0, &argc, argv);

   XtSetArg(args[0], XmNwidth, 250); 
   XtSetArg(args[1], XmNheight, 125); 
   form = XmCreateForm(toplevel, "form", (ArgList) args, 2);
   XtManageChild(form);

   XtSetArg(args[0], XmNtopAttachment, XmATTACH_FORM); 
   XtSetArg(args[1], XmNrightAttachment, XmATTACH_FORM);
   XtSetArg(args[2], XmNleftAttachment, XmATTACH_FORM); 
   menubar = XmCreateMenuBar(form, "menubar", args, 3); 
   XtManageChild(menubar);

/* Create help button in menubar */

   string = XmStringCreate("Help", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'H');
   menubarBtn[0] = XmCreateCascadeButton(menubar, "help", args, 2);
   XmStringFree(string);   
   XtAddCallback(menubarBtn[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Help");

   XtSetArg(args[0], XmNmenuHelpWidget, (XtArgVal)menubarBtn[0]);
   XtSetValues(menubar, args, 1);


/* Create 2 Pulldown MenuPanes and 2 cascade buttons in menubar */

   pulldowns[0] = XmCreatePulldownMenu(menubar, "pulldown1", NULL, 0);

   XtSetArg(args[0], XmNsubMenuId, pulldowns[0]);
   string = XmStringCreate("Left Menu", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[1], XmNlabelString, string);
   XtSetArg(args[2], XmNmnemonic, 'L');
   menubarBtn[1] = XmCreateCascadeButton(menubar, "button1", args, 3);
   XmStringFree(string);   

   pulldowns[1] = XmCreatePulldownMenu(menubar, "pulldown2", NULL, 0);

   XtSetArg(args[0], XmNsubMenuId, pulldowns[1]);
   string = XmStringCreate("Right Menu", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[1], XmNlabelString, string);
   XtSetArg(args[2], XmNmnemonic, 'R');
   menubarBtn[2] = XmCreateCascadeButton(menubar, "button2", args, 3);
   XmStringFree(string);   
   XtManageChildren(menubarBtn, 3);


   string = XmStringCreate("First", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'F');
   buttons1[0] = XmCreatePushButtonGadget(pulldowns[0], "button1a", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons1[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Left-First");

   string = XmStringCreate("Second", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'S');
   buttons1[1] = XmCreatePushButtonGadget(pulldowns[0], "button1b", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons1[1], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Left-Second");

   string = XmStringCreate("Third", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'T');
   buttons1[2] = XmCreatePushButtonGadget(pulldowns[0], "button1c", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons1[2], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Left-Third");
   XtManageChildren(buttons1, 3);


   string = XmStringCreate("First", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'F');
   buttons2[0] = XmCreatePushButtonGadget(pulldowns[1], "button2a", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons2[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Right-First");

   string = XmStringCreate("Second", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'S');
   buttons2[1] = XmCreatePushButtonGadget(pulldowns[1], "button2b", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons2[1], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Right-Second");

   string = XmStringCreate("Third", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   XtSetArg(args[1], XmNmnemonic, 'T');
   buttons2[2] = XmCreatePushButtonGadget(pulldowns[1], "button2c", args, 2);
   XmStringFree(string);   
   XtAddCallback(buttons2[2], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"Right-Third");
   XtManageChildren(buttons2, 3);

/* Get and dispatch events */

   XtRealizeWidget(toplevel);

   XtMainLoop();
}


